import signal
from threading import Timer


class TestTimer(Timer):
    def __init__(self, interval):
        super(TestTimer, self).__init__(interval, None)

    def run(self):
        while not self.finished.wait(timeout=self.interval):
            self.work()

    def work(self):
        print('doing another work thing')

    def start_timer(self):
        self.start()

    def cancelISR(self, *args, **kwargs):
        self.cancel()
        print('cancelled')


if __name__ == '__main__':
    t = TestTimer(2)
    t.start_timer()
    signal.signal(signal.SIGINT, t.cancelISR)
